----------------------------------------------------------------------------------
--  
--        AD9707.vhd        c`Ro[^[C^[tF[X
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
-- Number of Slices:                        8  out of   2448     0%  
-- Number of Slice Flip Flops:             14  out of   4896     0%  
-- Number of 4 input LUTs:                 13  out of   4896     0%  
--
--   Minimum period: 2.241ns (Maximum Frequency: 446.259MHz)
--   Minimum input arrival time before clock: 3.090ns
--   Maximum output required time after clock: 4.040ns
--   Maximum combinational path delay: No path found

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;


entity ad9707 is
  port (
    RESET   : in  STD_LOGIC;
    CLK     : in  STD_LOGIC;
    CLK_180 : in  STD_LOGIC;
    MCE     : in  std_logic;                        -- Module Chip Enable
    MWE     : in  STD_LOGIC;
    MWDATA  : in  STD_LOGIC_VECTOR (7 downto 0);    -- 0  0:dds0  1:dds1
    
    AMP     : in  std_logic_vector (17 downto 0);   -- `lϒEUx
    DDS0_IN : in  STD_LOGIC_VECTOR (17 downto 0);   -- DDS0́@2̕␔\
    DDS1_IN : in  STD_LOGIC_VECTOR (17 downto 0);   -- DDS1́@2̕␔\
    
    DAC_DATA  : out STD_LOGIC_VECTOR (13 downto 0); -- AD9707 DATA@Q̕␔\
    DAC_CLK   : in  std_logic;                      -- AD9707 CLK             P84
    DAC_PIN   : out std_logic;                      -- AD9707 PIN             P81
    DAC_MODE  : out std_logic;                      -- AD9707 MODE            P82
    DAC_CMODE : out std_logic                       -- AD9707 CMODE           P83
  );
end ad9707;


architecture RTL of ad9707 is
  
  signal SEL : STD_LOGIC_VECTOR (1 downto 0) ;
  signal mul_in  : STD_LOGIC_VECTOR (17 downto 0) ; -- 
  signal mul_out : STD_LOGIC_VECTOR (35 downto 0) ; -- 
  signal DAC_DATA0 : STD_LOGIC_VECTOR (14 downto 0) ; -- 
  signal DAC_DATA1 : STD_LOGIC_VECTOR (14 downto 0) ; -- 
  
  signal PHASE     : STD_LOGIC_VECTOR ( 2 downto 0) ; -- 12.5MHz
  signal TEST      : STD_LOGIC_VECTOR ( 3 downto 0) ; -- 
  signal TESTDATA  : STD_LOGIC_VECTOR (13 downto 0) ; -- 
  
begin
  
  mul : MULT18X18S
  port map (
    P => mul_out,     -- 36-bit multiplier output
    A => mul_in,      -- 18-bit multiplier input
    B => AMP,         -- 18-bit multiplier input
    C => CLK,         -- Clock input
    CE => '1',        -- Clock enable input  
    R => '0'          -- Synchronous reset input
  );  
  
  mul_in <=  DDS0_IN          when( SEL(0) = '0' ) else
             DDS1_IN;
  
  
  TESTDATA <= "00000000000000" when( TEST="0000" ) else
              "00000000000001" when( TEST="0001" ) else
              "00000000000010" when( TEST="0010" ) else
              "00000000000100" when( TEST="0011" ) else
              "00000000001000" when( TEST="0100" ) else
              "00000000010000" when( TEST="0101" ) else
              "00000000100000" when( TEST="0110" ) else
              "00000001000000" when( TEST="0111" ) else
              "00000010000000" when( TEST="1000" ) else
              "00000100000000" when( TEST="1001" ) else
              "00001000000000" when( TEST="1010" ) else
              "00010000000000" when( TEST="1011" ) else
              "00100000000000" when( TEST="1100" ) else
              "01000000000000" when( TEST="1101" ) else
              "10000000000000";
  
  ------------------------------------------------------------------
  --    ݒ
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if( RESET = '1' ) then
      SEL  <= "00";
    elsif( rising_edge(CLK) ) then
      if( MCE = '1' and MWE = '1' ) then
        SEL  <= MWDATA(1 downto 0);
        TEST <= MWDATA(7 downto 4);
      end if;
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --    c`o
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      DAC_DATA0 <= mul_out(34 downto 20);     -- xb`Ă
    end if;
  end process;
  
  
--  process( CLK_180 ) begin
--    if( rising_edge(CLK_180) ) then
  process( CLK ) begin
    if( falling_edge(CLK) ) then    -- ISE14.2 ł CLK_180 gƔzG[ɂȂ邽 falling_edge CLK ɕύX
      if( SEL(1) = '1' ) then
        DAC_DATA1 <= DAC_DATA0;     -- PWOxNbN̂߈xb`Ă
      
        if( DAC_DATA1(0)='1' ) then
          DAC_DATA  <= DAC_DATA1(14 downto 1) + 1; -- ÔP 20120521 0825
        else
          DAC_DATA  <= DAC_DATA1(14 downto 1);
        end if;
        
      else                              -- eXg[h
        if( PHASE(2) = '1' ) then
          DAC_DATA  <= TESTDATA;
        else
          DAC_DATA  <= (others => '0');
        end if;
      end if;
    end if;
  end process;
  
  
--  process( CLK_180 ) begin
--    if( rising_edge(CLK_180) ) then
  process( CLK ) begin
    if( falling_edge(CLK) ) then    -- ISE14.2 ł CLK_180 gƔzG[ɂȂ邽 falling_edge CLK ɕύX
      PHASE <= PHASE + 1;
    end if;
  end process;
  
  ------------------------------------------------------------------
  --    c`o
  ------------------------------------------------------------------
  DAC_PIN   <= '1';           -- PIN    0:SPI     1:PIN
  DAC_MODE  <= '1';           -- MODE   0:binary  1:2's complement
  DAC_CMODE <= '0';           -- CMODE  0:single-ended CLK  1:differential CLK
  
  
end RTL;
