----------------------------------------------------------------------------------
--  
--        adc1610s.vhd        ADC1610S(16bit 100MSPS) ̐
--  
--        (c)2011/11/14  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
--  ƓIp͂߂B
--
--
--
--  WRITE
--      0  ނ SPI ʐMJnis=2usj
--      1  bit7=R/~W  bit6..0=SPI Adrs
--      2  SPI ݃f[^
--      3  
--      4  ނ DLY lω DLY lƂ̃G[e[u쐬Jn
--      5  IODELAY ݒ
--
--  READ
--      0  SPI ǂݏof[^
--      1  
--      2  ADC f[^( 7..0)ǂݏo
--      3  ADC f[^(15..8)ǂݏo
--      4  ERROR by IODELAY ( 7..0)  IODELAY ̒l16ƂɃG[ǂe[u
--      5  ERROR by IODELAY (15..8)
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

library UNISIM;
use UNISIM.VComponents.all;


------------------------------------------------------------------------------
entity adc1610s is
  port (
    RESET     : in  std_logic;
    CLK       : in  std_logic;                      -- clock
    CLK_90    : in  std_logic;                      -- 90x clock
    CLK_180   : in  std_logic;                      -- ]clock
    CLK_270   : in  std_logic;                      -- 270x clock
    MCE       : in  std_logic;                      -- module select
    MWE       : in  std_logic;                      -- Module Write Enable
    MRE       : in  std_logic;                      -- Module Read Enable
    MADR      : in  std_logic_vector(15 downto 0);  -- address bus
    MWDATA    : in  std_logic_vector( 7 downto 0);  -- W[݃f[^
    MRDATA    : out std_logic_vector( 7 downto 0);  -- data bus output
    
    ADC_CS_X  : out std_logic;                      -- ADC1610 CS#            P121
    ADC_SDIO  : inout  std_logic;                   -- ADC1610 SDIO           P123
    ADC_SCLK  : out std_logic;                      -- ADC1610 SCLK           P124
    ADC_DATAIN: in  std_logic_vector (15 downto 0); -- ADC1610 D0..15         P126..6
    ADC_OTR   : in  std_logic;                      -- ADC1610 OTR            P7
    ADC_CLKP  : in  std_logic;                      -- ADC1610 CLKP           P8
    
    ADCDATA   : out std_logic_vector (15 downto 0);   -- 
    
    DEBUG     : out std_logic
  );
end adc1610s;


------------------------------------------------------------------------------
architecture RTL of adc1610s is
  signal ADC_DATA_DIFF  : std_logic_vector( 7 downto 0);  -- IBUFDS o
  signal ADC_DATA_DLY   : std_logic_vector( 7 downto 0);  -- IODELAY2 o
  signal ADC_DATA_DDR   : std_logic_vector(15 downto 0);  -- IDDR2 o
  signal ADCDATA1        : std_logic_vector(15 downto 0);  -- ADf[^
  signal ADC_DAV_DIFF   : std_logic;                      -- 
  signal ADC_DAV_DDR    : std_logic_vector( 1 downto 0);  -- 
  
  signal DLY_CAL        : std_logic;                      -- IODELAY2 
  signal DLY_INC        : std_logic;                      -- IODELAY2 0:decrement? 1:increment
  signal DLY_RST        : std_logic;                      -- IODELAY2 
  
  signal DLYERRTBLSTART : std_logic;                      -- DLY lςG[ɂȂ邩ׂ
  signal DLYVALUE       : std_logic_vector( 7 downto 0);  -- DLY ݒl
  signal DLYSETSTART    : std_logic;                      -- DLY lݒJn
  signal DLYERRTBLEXEC  : std_logic;                      -- G[e[u쐬
  signal DLYSETEXEC     : std_logic;                      -- DLY lݒ蒆
  signal DLYVALUECNT    : std_logic_vector( 7 downto 0);  -- IODELAY DLY JE^[
  signal DLYERRTBL      : std_logic_vector(15 downto 0);  -- IODELAY DLYl 16 ƂɓǂݏoG[ɂȂǂ
  signal DLYERR         : std_logic;                      -- ǂݏoG[ɂȂǂ
  signal DLYSTATE       : integer range 0 to 8 ;
  signal DLYCNT         : std_logic_vector( 2 downto 0);  -- ԑ҂JE^[
  
  signal SPISTART : std_logic;
  signal SPISDIOZ : std_logic;
  signal SPIADRS  : std_logic_vector ( 5 downto 0);
  signal SPIRW    : std_logic;
  signal SPIWDATA : std_logic_vector ( 7 downto 0);
  signal SPIRDATA : std_logic_vector ( 7 downto 0);
  signal SPIDATA  : std_logic_vector (23 downto 0);
  signal SPICNT   : std_logic_vector ( 4 downto 0);
  signal SPIEXEC  : std_logic;
  signal SPICLKCNT   : std_logic_vector ( 2 downto 0);  -- 
  
  signal ADCRDATA : std_logic_vector (15 downto 0);
  
begin
  
  
  ------------------------------------------------------------------
  --  ADC1610S Ƃ̐ڑ|[gݒ
  ------------------------------------------------------------------
  ADC_DAV_IDDR2_inst : IDDR2
  generic map(
    DDR_ALIGNMENT => "NONE",  -- Sets output alignment to "NONE", "C0", "C1"
    INIT_Q0       => '0',     -- Sets initial state of the Q0 output to f0f or f1f
    INIT_Q1       => '0',     -- Sets initial state of the Q1 output to f0f or f1f
    SRTYPE        => "SYNC"   -- Specifies "SYNC" or "ASYNC" set/reset
  )
  port map (
    Q0 => ADC_DAV_DDR(0),   -- 1-bit output captured with C0 clock
    Q1 => ADC_DAV_DDR(1),   -- 1-bit output captured with C1 clock
    C0 => CLK,              -- 1-bit clock input
--    C1 => CLK_180,          -- 1-bit clock input
    C1 => not CLK,          -- 1-bit clock input        ISE14.2 ł CLK_180 gƔzG[ɂȂ邽 not CLK ɕύX
    CE => '1',              -- 1-bit clock enable input
    D  => ADC_DAV_DIFF,     -- 1-bit data input
    R  => '0',              -- 1-bit reset input
    S  => '0'               -- 1-bit set input
  );
  
  
  ADC_DATA_Loop : for i in 0 to 7 generate
  begin
    ADC_DATA_IBUFDS_inst : IBUFDS
    generic map (
      DIFF_TERM     => TRUE,         -- Differential Termination
      IBUF_LOW_PWR  => TRUE,         -- Low power (TRUE) vs. performance (FALSE) setting for referenced I/O standards
      IOSTANDARD    => "LVDS_33"
    )
    port map (
      O   => ADC_DATA_DIFF(i),       -- Buffer output
      I   => ADC_DATAIN(2*i+1),      -- Diff_p buffer input (connect directly to top-level port)
      IB  => ADC_DATAIN(2*i)         -- Diff_n buffer input (connect directly to top-level port)
    );
    
    
    ADC_DATA_IODELAY2_inst : IODELAY2
    generic map (
      DATA_RATE           => "DDR",
      IDELAY_VALUE        => 0,
      IDELAY_TYPE         => "VARIABLE_FROM_ZERO",
      COUNTER_WRAPAROUND  => "STAY_AT_LIMIT",
      DELAY_SRC           => "IDATAIN",
      SERDES_MODE         => "NONE",
      SIM_TAPDELAY_VALUE  => 75
    )
    port map (
      IDATAIN   => ADC_DATA_DIFF(i), -- data from primary IOB
      DATAOUT   => ADC_DATA_DLY(i),  -- Output data 1 to ILOGIC/ISERDES2
      T         => '1',              -- tri-state control from OLOGIC/OSERDES2
      
      DATAOUT2  => open,             -- Output data 2 to ILOGIC/ISERDES2
      DOUT      => open,             -- output data to IOB
      ODATAIN   => '0',              -- data from OLOGIC/OSERDES2
      TOUT      => open,             -- tri-state control from OLOGIC/OSERDES2
      
      IOCLK0    => CLK,              -- High speed clock for calibration for SDR/DDR
--      IOCLK1    => CLK_180,          -- High speed clock for calibration for DDR
      IOCLK1    => not CLK,          -- High speed clock for calibration for DDR        ISE14.2 ł CLK_180 gƔzG[ɂȂ邽 not CLK ɕύX
      CLK       => CLK,              -- Fabric clock (GCLK) for control signals
      CAL       => DLY_CAL,          -- Calibrate control signal
      INC       => DLY_INC,          -- Increment counter
      CE        => DLY_INC,          -- Clock Enable
      BUSY      => open,             -- output signal indicating sync circuit has finished / calibration has finished
      RST       => DLY_RST           -- Reset delay line
    );
    
    
    ADC_DATA_IDDR2_inst : IDDR2
    generic map(
      DDR_ALIGNMENT => "NONE",         -- Sets output alignment to "NONE", "C0", "C1"
      INIT_Q0       => '0',          -- Sets initial state of the Q0 output to f0f or f1f
      INIT_Q1       => '0',          -- Sets initial state of the Q1 output to f0f or f1f
      SRTYPE        => "ASYNC"       -- Specifies "SYNC" or "ASYNC" set/reset
    )
    port map (
      Q0 => ADC_DATA_DDR(2*i),       -- 1-bit output captured with C0 clock
      Q1 => ADC_DATA_DDR(2*i+1),     -- 1-bit output captured with C1 clock
      C0 => CLK,                     -- 1-bit clock input
--      C1 => CLK_180,                 -- 1-bit clock input
      C1 => not CLK,                 -- 1-bit clock input        ISE14.2 ł CLK_180 gƔzG[ɂȂ邽 not CLK ɕύX
      CE => '1',                     -- 1-bit clock enable input
      D  => ADC_DATA_DLY(i),         -- 1-bit data input
      R  => '0',                     -- 1-bit reset input
      S  => '0'                      -- 1-bit set input
    );
  end generate ADC_DATA_Loop;
  
  
  ADCDATA  <= ADCDATA1;
  
  
  
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      ADCDATA1 <= not ADC_DATA_DDR; -- ADC1610  FPGA ̐ڑō͂ P  N tȂ̂Ŕ]B
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --  ǂݏo
  ------------------------------------------------------------------
  MRDATA <= (others =>'0')         when(MCE='0') else
            SPIRDATA               when(MADR(2 downto 0)="000") else -- SPI ǂݏof[^
            ADCRDATA( 7 downto 0)  when(MADR(2 downto 0)="010") else -- ADC f[^( 7..0)
            ADCRDATA(15 downto 8)  when(MADR(2 downto 0)="011") else -- ADC f[^(15..8)
            DLYERRTBL( 7 downto 0) when(MADR(2 downto 0)="100") else -- DLY G[e[u(15..8)
            DLYERRTBL(15 downto 8);                                  -- DLY G[e[u( 7..0)
  
  
  process( RESET, CLK ) begin
    if( RESET = '1' ) then
      ADCRDATA  <= ( others => '0');
    elsif( rising_edge(CLK) ) then
      if( MCE = '1' and MRE = '1' ) then
        if( MADR(1 downto 0)="10" ) then
          ADCRDATA  <= ADCDATA1;   -- ADCf[^ʃoCg܂߃b`
        end if;
      end if;
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --  
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if( RESET='1' ) then
      SPISTART       <= '0';               -- SPI ʐMJn
      SPIADRS        <= ( others => '0');
      SPIWDATA       <= ( others => '0');
      DLYERRTBLSTART <= '0';               -- DLY lωG[e[u쐬Jn
      DLYVALUE       <= ( others => '0');  -- IODELAY ݒl
      DLYSETSTART    <= '0';               -- DLY lݒJn
    elsif( rising_edge(CLK) ) then
      if( MCE='1' and MWE='1' ) then
          if( MADR(2 downto 0)="000" ) then 
            SPISTART <= '1';                    -- SPI ʐMJn
          elsif( MADR(2 downto 0)="001" ) then
            SPIADRS <= MWDATA( 5 downto 0);       -- bit6..0=Adrs
            SPIRW   <= MWDATA( 7 );               -- bit7=R/~W
          elsif( MADR(2 downto 0)="010" ) then
            SPIWDATA <= MWDATA;
          elsif( MADR(2 downto 0)="100" ) then
            DLYERRTBLSTART <= '1';                 -- DLY lωG[e[u쐬Jn
          elsif( MADR(2 downto 0)="101" ) then
            DLYVALUE <= MWDATA;                   -- IODELAY ݒl
            DLYSETSTART <= '1';                   -- DLY lݒJn
          end if;
      else
        SPISTART       <= '0';
        DLYERRTBLSTART <= '0';
        DLYSETSTART    <= '0';
      end if;
    end if;
  end process;
  
  
  
  ------------------------------------------------------------------
  --  SPI ʐM
  ------------------------------------------------------------------
  ADC_SDIO   <= SPIDATA(23) when( SPISDIOZ='0' ) else 'Z';
  
  
  process( RESET, CLK ) begin
    if( RESET='1' ) then
      SPIEXEC  <= '0';
      SPICNT   <= ( others => '0');
      SPICLKCNT   <= ( others => '0');
      SPIDATA  <= ( others => '0');
      ADC_CS_X <= '1';
      ADC_SCLK <= '0';
      SPISDIOZ <= '1';
    elsif( rising_edge(CLK) ) then
      if( SPIEXEC='0' ) then
        if( SPISTART='1' ) then
          SPIEXEC  <= '1';                                         -- SPI ʐMJn
          SPICNT   <= ( others => '0');
          SPICLKCNT   <= ( others => '0');
          SPIDATA  <= SPIRW & "000000000" & SPIADRS & SPIWDATA;  -- Mf[^
          ADC_CS_X <= '0';
          ADC_SCLK <= '0';
          SPISDIOZ <= '0';
        end if;
      else
        
        if( SPICLKCNT="110" ) then
          SPIDATA <= SPIDATA(22 downto 0) & "0";            -- f[^o
          SPICNT  <= SPICNT+1;
        elsif( SPICLKCNT="100" ) then
          SPIRDATA <= SPIRDATA( 6 downto 0 ) & ADC_SDIO;        -- f[^
        end if;
        SPICLKCNT <= SPICLKCNT+1;
        
        if( SPICNT(4)='1' ) then
          if( SPIRW='1' ) then
            SPISDIOZ <= '1';          -- Hi Z
          end if;
        end if;
        
        if( SPICNT(4 downto 3)="11" ) then
          SPIEXEC  <= '0';              -- SPI ʐMI
          ADC_CS_X <= '1';              -- 
          SPISDIOZ <= '1';
        end if;
        
      end if;
      
      ADC_SCLK <= SPICLKCNT(2);
      
    end if;
  end process;
  
  
  
  ------------------------------------------------------------------
  --  IODELAY2  DLY lݒADLY lƂ̃G[e[u쐬
  ------------------------------------------------------------------
  process( RESET, CLK )
    variable err : std_logic;
  begin
    if( RESET='1' ) then
      DLYERRTBLEXEC <= '0';
      DLYSETEXEC    <= '0';
      DLYERRTBL     <= ( others => '0');
      DLY_CAL <= '1';         -- CAL P񂾂s
      DLY_INC <= '0';
      DLY_RST <= '0';
    elsif( rising_edge(CLK) ) then
      if( DLYERRTBLEXEC='0' and  DLYSETEXEC='0' ) then  -- ǂsł͂ȂȂ
        if( DLYERRTBLSTART='1' ) then
          DLYERRTBLEXEC <= '1';       -- G[e[u쐬Jn
          DLY_RST     <= '1';           -- ܂̓Zbg
          DLYVALUECNT <= ( others => '0');
          DLYCNT      <= ( others => '0');
          DLYERRTBL   <= ( others => '0');
          DLYERR      <= '0';
          DLYSTATE <= 1;
        elsif( DLYSETSTART='1' ) then
          DLYSETEXEC  <= '1';           -- DLY lݒJn
          DLY_RST     <= '1';           -- ܂̓Zbg
          DLYVALUECNT <= ( others => '0');
          DLYSTATE    <= 1;
        end if;
        
      else
        DLY_RST  <= '0';
        
        if( DLYSTATE=1 ) then
          DLY_INC <= '0';
          if( DLYERRTBLEXEC = '1' ) then  -- G[e[u쐬
            if( DLYCNT(2) = '1' ) then    -- ADCDATA1 肷܂ő҂
              if( ADCDATA1 /= X"AAAA" ) then -- p^[ 0xAAAA ƈvȂG[
                err := '1';
              else
                err := '0';
              end if;
              if( DLYVALUECNT(3 downto 0) = "1111" ) then -- PUG[G[e[uɓ
                DLYERRTBL <= (err or DLYERR) & DLYERRTBL(15 downto 1);
                DLYERR <= '0';
                if( DLYVALUECNT(7 downto 4) = "1111" ) then
                  DLYERRTBLEXEC <= '0'; -- G[e[u쐬
                end if;
              else
                DLYERR <= err or DLYERR;
              end if;
              DLYSTATE <= 2;
              DLYCNT <= ( others => '0');
            end if;
            DLYCNT <= DLYCNT + 1;
            
          elsif( DLYSETEXEC = '1' ) then  -- DLY lݒ
            if( DLYVALUECNT = DLYVALUE ) then
              DLYSETEXEC <= '0';          -- ݒ芮
            end if;
            DLYSTATE <= 2;
            
          end if;
          
        elsif( DLYSTATE=2 ) then
          DLY_INC <= '1';               -- DLY CNg
          DLYVALUECNT <= DLYVALUECNT+1;
          DLYSTATE <= 1;
        end if;
        
      end if;
      
      DLY_CAL <= '0';
    end if;
  end process;
  
  
  
  
end RTL;
----------------------------- end of architecture ----------------------------
