----------------------------------------------------------------------------------
--  
--        dds3.vhd        ccriphase:32bits  out:16bitsjQ
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
-- PHASE:32bits
-- Number of Slices:                      234  out of   2448     9%  
-- Number of Slice Flip Flops:            176  out of   4896     3%  
-- Number of 4 input LUTs:                446  out of   4896     9%  
--
-- PHASE:24bits
-- Number of Slices:                      226  out of   2448     9%  
-- Number of Slice Flip Flops:            160  out of   4896     3%  
-- Number of 4 input LUTs:                430  out of   4896     8%  
--
--   Minimum period: 8.500ns (Maximum Frequency: 117.651MHz)
--   Minimum input arrival time before clock: 4.648ns
--   Maximum output required time after clock: 6.920ns
--   Maximum combinational path delay: 6.747ns
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

Library UNISIM;
use UNISIM.vcomponents.all;

------------------------------------------------------------------------------
entity dds3 is
  port (
    RESET   : in  std_logic;
    DDSCLK  : in  std_logic;
    FREQ1   : in  std_logic_vector(23 downto 0);    -- gP
    FREQ2   : in  std_logic_vector(23 downto 0);    -- gQ
    PHASE2_INIT  : in  std_logic_vector(15 downto 0);    -- ʑQ̏l
    WAVE1   : in  std_logic_vector(1 downto 0);     -- g`ނP
    WAVE2   : in  std_logic_vector(1 downto 0);     -- g`ނQ
    SIG1    : out std_logic_vector(15 downto 0);    -- Mo͂P
    SIG2    : out std_logic_vector(15 downto 0)     -- Mo͂Q
  );
end dds3;

------------------------------------------------------------------------------
architecture RTL of dds3 is
  
  signal PHASE1  : STD_LOGIC_VECTOR (31 downto 0);
  signal SINE1   : STD_LOGIC_VECTOR (15 downto 0);
  signal SQUARE1 : STD_LOGIC_VECTOR (15 downto 0);
  signal SAW1    : STD_LOGIC_VECTOR (15 downto 0);
  signal TRIAGL1 : STD_LOGIC_VECTOR (15 downto 0);
  
  signal PHASE2  : STD_LOGIC_VECTOR (31 downto 0);
  signal SINE2   : STD_LOGIC_VECTOR (15 downto 0);
  signal SQUARE2 : STD_LOGIC_VECTOR (15 downto 0);
  signal SAW2    : STD_LOGIC_VECTOR (15 downto 0);
  signal TRIAGL2 : STD_LOGIC_VECTOR (15 downto 0);
  
  signal PHASE   : STD_LOGIC_VECTOR (15 downto 0);
  signal SINE    : STD_LOGIC_VECTOR (15 downto 0);
  signal ND      : STD_LOGIC;
  signal OD      : STD_LOGIC;
  
  signal CNT     : STD_LOGIC_VECTOR (5 downto 0);
  
  
  component cordic_sine
  port (
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- ͈ʑCl[u
    PHASE   : in  std_logic_vector( 15 downto 0 ); -- ʑ
    SINE_OUT: out std_logic_vector( 15 downto 0 ); -- o̓f[^
    OD      : out std_logic                        -- o̓f[^Cl[u
  );
  end component;
  
  
  begin
    
    u0 : cordic_sine        -- DDS 2ŋp
    port map (
      CLK     => DDSCLK,    -- 
      ND      => ND,        -- ͈ʑCl[u
      PHASE   => PHASE,     -- ʑ
      SINE_OUT=> SINE,      -- o̓f[^
      OD      => OD         -- o̓f[^Cl[u
    );
    
    
    PHASE <= PHASE1(31 downto 16) when( CNT(5)='0' ) else
             PHASE2(31 downto 16);
    
    
    ------------------------------------------------------------------
    --    TC
    ------------------------------------------------------------------
    process( DDSCLK ) begin
      if( rising_edge(DDSCLK) ) then
        if( OD='1' ) then
          if( CNT(5)='0' ) then
            SINE1 <= SINE;
          else
            SINE2 <= SINE;
          end if;
        end if;
      end if;
    end process;
    
    
    
    ------------------------------------------------------------------
    --    CORDIC 𐧌䂷JE^[
    ------------------------------------------------------------------
    process( DDSCLK ) begin
      if( rising_edge(DDSCLK) ) then
        CNT <= CNT + 1;
        if( CNT="000000" or CNT="100000" ) then
          ND <= '1';
        else
          ND <= '0';
        end if;
      end if;
    end process;
    
    
    
    ------------------------------------------------------------------
    
    SIG1 <= SINE1   when( WAVE1 = "00" ) else
            SQUARE1 when( WAVE1 = "01" ) else
            SAW1    when( WAVE1 = "10" ) else
            TRIAGL1;
    
    SQUARE1 <= X"7FFF" when(PHASE1(31)='1') else
               X"8000" ;
    
    SAW1    <= PHASE1(31 downto 16);
    
    TRIAGL1 <= ("0"&PHASE1(29 downto 15))        when(PHASE1(31 downto 30)="00") else
               ("0"&(not(PHASE1(29 downto 15)))) when(PHASE1(31 downto 30)="01") else
               ("1"&(not(PHASE1(29 downto 15)))) when(PHASE1(31 downto 30)="10") else
               ("1"&PHASE1(29 downto 15));
    
    ------------------------------------------------------------------
    --    ʑAL[^[P
    ------------------------------------------------------------------
    process( RESET, DDSCLK ) begin
      if( RESET = '1' ) then
        PHASE1 <= (others => '0');
      elsif( rising_edge(DDSCLK) ) then
        PHASE1 <= PHASE1 + FREQ1;
--        PHASE11 <= PHASE1(31 downto 16) + PHASE1(15);
      end if;
    end process;
    
    
    
    ------------------------------------------------------------------
    
    SIG2 <= SINE2   when( WAVE2 = "00" ) else
            SQUARE2 when( WAVE2 = "01" ) else
            SAW2    when( WAVE2 = "10" ) else
            TRIAGL2;
    
    SQUARE2 <= X"7FFF" when(PHASE2(31)='1') else
               X"8000" ;
    
    SAW2  <= PHASE2(31 downto 16);
    
    TRIAGL2 <= ("0"&PHASE2(29 downto 15))        when(PHASE2(31 downto 30)="00") else
               ("0"&(not(PHASE2(29 downto 15)))) when(PHASE2(31 downto 30)="01") else
               ("1"&(not(PHASE2(29 downto 15)))) when(PHASE2(31 downto 30)="10") else
               ("1"&PHASE2(29 downto 15));
    
    ------------------------------------------------------------------
    --    ʑAL[^[Q
    ------------------------------------------------------------------
    process( RESET, DDSCLK ) begin
      if( RESET = '1' ) then
        PHASE2 <= PHASE2_INIT & "0000000000000000";
      elsif( rising_edge(DDSCLK) ) then
        PHASE2 <= PHASE2 + FREQ2;
      end if;
    end process;
    
    
    
  end RTL;
----------------------------- end of architecture ----------------------------
