----------------------------------------------------------------------------------
--  
--        dds.vhd        
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--
-- Number of Slices:                      679  out of   2448    27%  
-- Number of Slice Flip Flops:            665  out of   4896    13%  
-- Number of 4 input LUTs:               1143  out of   4896    23%  
-- 
--   Minimum period: 10.054ns (Maximum Frequency: 99.466MHz)
--   Minimum input arrival time before clock: 4.942ns
--   Maximum output required time after clock: 7.015ns
--   Maximum combinational path delay: No path found
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

------------------------------------------------------------------------------
entity dds is
  port (
    RESET   : in  std_logic;
    CLK     : in  std_logic;                      -- io bus clock
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MADR    : in  std_logic_vector(15 downto 0 ); -- W[AhX
    MWDATA  : in  std_logic_vector( 7 downto 0 ); -- W[֏ރf[^
    
    COS0    : out std_logic_vector(17 downto 0);  -- ccrO@o
    SIN0    : out std_logic_vector(17 downto 0);
    
    SIG1    : out std_logic_vector(17 downto 0);  -- ccrP@o
    
    SIG2    : out std_logic_vector(15 downto 0);  -- ccrQ@o
    
    SIG3    : out std_logic_vector(15 downto 0)   -- ccrR@o
    
  );
end dds;

------------------------------------------------------------------------------
architecture RTL of dds is
  
  signal PHASE_RESET  : std_logic;                    -- ʑZbg
  signal FREQ0 : STD_LOGIC_VECTOR (31 downto 0);
  signal FREQ1 : STD_LOGIC_VECTOR (23 downto 0);
  signal FREQ2 : STD_LOGIC_VECTOR (23 downto 0);
  signal PHASE2_INIT : STD_LOGIC_VECTOR (15 downto 0);
  signal WAVE1 : STD_LOGIC_VECTOR (1 downto 0);
  signal WAVE2 : STD_LOGIC_VECTOR (1 downto 0);
  
  component dds0
  port (
    DDSCLK  : in  std_logic;
    FREQ    : in  std_logic_vector(31 downto 0);    -- g
    COS     : out std_logic_vector(17 downto 0);    -- RTCo
    SIN     : out std_logic_vector(17 downto 0)     -- TCo
  );
  end component;
  
  component dds1
  port (
    DDSCLK  : in  std_logic;
    FREQ    : in  std_logic_vector(31 downto 0);    -- g
    SIG     : out std_logic_vector(17 downto 0)     -- Mo
  );
  end component;
  
  
  component dds3
  port (
    RESET   : in  std_logic;
    DDSCLK  : in  std_logic;
    FREQ1   : in  std_logic_vector(23 downto 0);    -- gP
    FREQ2   : in  std_logic_vector(23 downto 0);    -- gQ
    PHASE2_INIT  : in  std_logic_vector(15 downto 0);    -- ʑQ̏l
    WAVE1   : in  std_logic_vector(1 downto 0);     -- g`ނP
    WAVE2   : in  std_logic_vector(1 downto 0);     -- g`ނQ
    SIG1    : out std_logic_vector(15 downto 0);    -- Mo͂P
    SIG2    : out std_logic_vector(15 downto 0)     -- Mo͂Q
  );
  end component;
  
  
begin
  
  u0 : dds0
  port map (
    DDSCLK  => CLK,
    FREQ    => FREQ0,       -- g
    COS     => COS0,        -- RTCo
    SIN     => SIN0         -- TCo
  );
  
  u1 : dds1
  port map (
    DDSCLK  => DDSCLK,
    FREQ    => FREQ1MOD,    -- g
    SIG     => SIG1         -- Mo
  );
  
  
  u3 : dds3
  port map (
    RESET   => PHASE_RESET,           -- ʑZbg
    DDSCLK  => CLK,
    FREQ1   => FREQ2,                 -- gP
    FREQ2   => FREQ3,                 -- gQ
    PHASE2_INIT=> PHASE2_INIT,        -- ʑQ̏l
    WAVE1   => WAVE2,                 -- g`ނP
    WAVE2   => WAVE3,                 -- g`ނQ
    SIG1    => SIG2,                  -- Mo͂P
    SIG2    => SIG3                   -- Mo͂Q
  );
  
  
  ------------------------------------------------------------------
  --    eccr̎gݒ
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if ( RESET ='1') then
      FREQ0 <= X"028F5C28";           -- 1MHz
--      FREQ0 <= X"0020C49B";           -- 50kHz
      FREQ1 <= X"00A7C5";             -- 1kHz
      FREQ2 <= X"014F8B";             -- 2kHz
      PHASE2_INIT <= (others => '0'); -- ʑQ̏l ccrR
      WAVE1 <= "00";                  -- TC
      WAVE2 <= "00";                  -- TC
    elsif( rising_edge(CLK) ) then
      if( MWE='1' and MCE='1' ) then
        case MADR( 3 downto 0 ) is
          when( "0000" ) => FREQ0( 7 downto  0) <= MWDATA;    -- gݒ ccrO
          when( "0001" ) => FREQ0(15 downto  8) <= MWDATA;    -- gݒ ccrO
          when( "0010" ) => FREQ0(23 downto 16) <= MWDATA;    -- gݒ ccrO
          when( "0011" ) => FREQ0(31 downto 24) <= MWDATA;    -- gݒ ccrO
          when( "0100" ) => FREQ1( 7 downto  0) <= MWDATA;    -- gPݒ ccrR
          when( "0101" ) => FREQ1(15 downto  8) <= MWDATA;    -- gPݒ ccrR
          when( "0110" ) => FREQ1(23 downto 16) <= MWDATA;    -- gPݒ ccrR
          when( "0111" ) => WAVE1               <= MWDATA(1 downto 0);    -- g`Pݒ ccrR
          when( "1000" ) => FREQ2( 7 downto  0) <= MWDATA;    -- gQݒ ccrR
          when( "1001" ) => FREQ2(15 downto  8) <= MWDATA;    -- gQݒ ccrR
          when( "1010" ) => FREQ2(23 downto 16) <= MWDATA;    -- gQݒ ccrR
          when( "1011" ) => WAVE2               <= MWDATA(1 downto 0);    -- g`Qݒ ccrR
          when( "1100" ) => PHASE2_INIT( 7 downto  0) <= MWDATA;    -- ʑQ̏l ccrR
          when( "1101" ) => PHASE2_INIT(15 downto  8) <= MWDATA;    -- ʑQ̏l ccrR
                            PHASE_RESET <= '1';               -- ʑZbg
          when others    => PHASE_RESET <= '0';
        end case;
      end if;
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------
