------------------------------------------------------------------------------
--       freqcounter.vhd    VvJgJE^[
--
--        (c)2011/03/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
----------------------------------------------------------------------------------
--
--Selected Device : 3s200avq100-5 
--
-- Number of Slices:                       59  out of   1792     3%  
-- Number of Slice Flip Flops:            102  out of   3584     2%  
-- Number of 4 input LUTs:                 47  out of   3584     1%  
-- Number of IOs:                         126
-- Number of bonded IOBs:                 125  out of     68   183% (*) 
-- Number of GCLKs:                         2  out of     24     8%  
--
--   Minimum period: 4.981ns (Maximum Frequency: 200.747MHz)
--   Minimum input arrival time before clock: 5.399ns
--   Maximum output required time after clock: 5.429ns
--   Maximum combinational path delay: No path found
--
----------------------------------------------------------------------------------


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

library UNISIM;
use UNISIM.Vcomponents.ALL;


entity freqcounter is 
  port (
    RESET     : in  std_logic;
    CLK       : in  std_logic; 
    
    CNT32     : in std_logic_vector(31 downto 0);  -- JE^[l
    
    SIGIN     : in  std_logic;                     -- M
    START     : in  std_logic;                     -- Jn
    STOP      : in  std_logic;                     -- I
    SEQ       : in  std_logic;                     -- 0:P   1: A
    MESBITSEL : in  std_logic_vector( 2 downto 0); -- 0:1/1  1:1/2  2:1/4 .... 7:1/128
    PRESCALER : in  std_logic_vector( 1 downto 0); -- 0:1/1  1:1/256  2:1/65536
    
    STATE     : out std_logic_vector( 1 downto 0);
    SEQCNT    : out std_logic_vector( 7 downto 0);
    MESCNT    : out std_logic_vector( 7 downto 0);
    CNT_START : out std_logic_vector(31 downto 0);
    CNT_STOP  : out std_logic_vector(31 downto 0);
    
    OD        : out std_logic                     -- VlL
    
  );
end freqcounter;


------------------------------------------------------------------------------
architecture RTL of freqcounter is
  
  signal CNT_START1 : std_logic_vector(31 downto 0);  -- JnJE^[l
  signal CNT_STOP1  : std_logic_vector(31 downto 0);  -- IJE^[l
  
  signal SEQCNT1    : std_logic_vector( 7 downto 0);  -- 
  signal PRECNT1    : std_logic_vector(15 downto 0);  -- vXP[[JE^[
  signal MESBIT     : std_logic;                      -- rbg
  signal MESBIT_D1  : std_logic;                      -- 
  signal MESCNT1     : std_logic_vector( 7 downto 0);  -- rbgJE^[
  
  signal SIG1       : std_logic;                      -- MivXP[[ON/OFFj
  signal SIG_D1     : std_logic;                      -- 
  signal SIG_D2     : std_logic;                      -- 
  
  signal STATE1       : std_logic_vector( 1 downto 0);  -- Xe[g
  constant STATE_STOP : std_logic_vector(1 downto 0) := "00"; -- I
  constant STATE_MES1 : std_logic_vector(1 downto 0) := "01"; -- JniMESBIT̗オ҂j
  constant STATE_MES2 : std_logic_vector(1 downto 0) := "10"; -- JnJE^[l̃TvOiIJE^[l͂܂j
  
  
begin
  
  ------------------------------------------------------------------
  --    Xe[g
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      MESBIT_D1 <= MESBIT;
      
      if( START='1' ) then
        CNT_START1 <= (others => '0');
        CNT_STOP1  <= (others => '0');
        STATE1    <= STATE_MES1;
        SEQCNT1   <= (others => '0');   -- 
        
      elsif( STOP='1' ) then
        STATE1 <= STATE_STOP;
        
      elsif( MESBIT='1' and MESBIT_D1='0' ) then
        if( STATE1 = STATE_MES1 ) then
          CNT_START1 <= CNT32;
          STATE1    <= STATE_MES2;
        elsif( STATE1 = STATE_MES2 ) then
          CNT_STOP1  <= CNT32;
          OD <= '1';                    -- VlL
          if( SEQ = '1' ) then
            SEQCNT1 <= SEQCNT1 + 1;
          else
            STATE1  <= STATE_STOP;
          end if;
        end if;
        
      else
        OD <= '0';
      end if;
    end if;
  end process;
  
  
  STATE  <= STATE1;
  SEQCNT <= SEQCNT1;
  CNT_START <= CNT_START1;
  CNT_STOP  <= CNT_STOP1;
  
  
  
  ------------------------------------------------------------------
  --    MJEg
  ------------------------------------------------------------------
  MESBIT <= SIG_D2       when(MESBITSEL=X"0") else     -- 
            MESCNT1(0)   when(MESBITSEL=X"1") else     -- 1/2
            MESCNT1(1)   when(MESBITSEL=X"2") else     -- 1/4
            MESCNT1(2)   when(MESBITSEL=X"3") else     -- 1/8
            MESCNT1(3)   when(MESBITSEL=X"4") else     -- 1/16
            MESCNT1(4)   when(MESBITSEL=X"5") else     -- 1/32
            MESCNT1(5)   when(MESBITSEL=X"6") else     -- 1/64
            MESCNT1(6);                                -- 1/128
  
  
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      SIG_D1 <= SIG1;
      SIG_D2 <= SIG_D1;
      if( START='1' ) then
        MESCNT1 <= (others => '0');      -- MĂ邩mF邽߂ŃZbg
      elsif( SIG_D1='1' and SIG_D2='0' ) then
        MESCNT1 <= MESCNT1 + 1;
      end if;
    end if;
  end process;
  
  
  MESCNT <= MESCNT1;
  
  ------------------------------------------------------------------
  --    vXP[[
  ------------------------------------------------------------------
  SIG1 <= SIGIN      when(PRESCALER="00") else 
          PRECNT1(7) when(PRESCALER="01") else 
          PRECNT1(15);
  
  
  process( SIGIN ) begin                -- 񓯊JE^[@gł삷悤ɁB
    if( rising_edge(SIGIN) ) then
      PRECNT1 <= PRECNT1 + 1;
    end if;
  end process;
  
  
  
end RTL;
----------------------------- end of architecture ----------------------------

