--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:52:32 08/22/2011
-- Design Name:   
-- Module Name:   D:/ogchan/WorkShop/ISE/APB3/ft232h_asyncfifo_tb.vhd
-- Project Name:  APB3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: ft232h
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY ft232h_asyncfifo_tb IS
END ft232h_asyncfifo_tb;
 
ARCHITECTURE behavior OF ft232h_asyncfifo_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT ft232h
    PORT(
         RESET : IN  std_logic;
         CLK : IN  std_logic;
         FT232_RXF_X : IN  std_logic;
         FT232_TXE_X : IN  std_logic;
         FT232_RD_X : OUT  std_logic;
         FT232_WR_X : OUT  std_logic;
         FT232_SIWU_X : OUT  std_logic;
--         FT232_CLK : OUT  std_logic;
         FT232_D_OUT : OUT  std_logic_vector(7 downto 0);
         FT232_D_IN : IN  std_logic_vector(7 downto 0);
         FT232_DIR : OUT  std_logic;
         MWE : OUT  std_logic;
         MCE : OUT  std_logic_vector(15 downto 0);
         MWDATA : OUT  std_logic_vector(7 downto 0);
         MRDATA : IN  std_logic_vector(7 downto 0);
         MADR : OUT  std_logic_vector(15 downto 0)
--         TEST : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal RESET : std_logic := '0';
   signal CLK : std_logic := '0';
   signal FT232_RXF_X : std_logic := '0';
   signal FT232_TXE_X : std_logic := '0';
   signal FT232_D_IN : std_logic_vector(7 downto 0) := (others => '0');
   signal MRDATA : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal FT232_RD_X : std_logic;
   signal FT232_WR_X : std_logic;
   signal FT232_SIWU_X : std_logic;
--   signal FT232_CLK : std_logic;
   signal FT232_D_OUT : std_logic_vector(7 downto 0);
   signal FT232_DIR : std_logic;
   signal MWE : std_logic;
   signal MCE : std_logic_vector(15 downto 0);
   signal MWDATA : std_logic_vector(7 downto 0);
   signal MADR : std_logic_vector(15 downto 0);
--   signal TEST : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant CLK_period : time := 10 ns;
   constant FT232_CLK_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: ft232h PORT MAP (
          RESET => RESET,
          CLK => CLK,
          FT232_RXF_X => FT232_RXF_X,
          FT232_TXE_X => FT232_TXE_X,
          FT232_RD_X => FT232_RD_X,
          FT232_WR_X => FT232_WR_X,
          FT232_SIWU_X => FT232_SIWU_X,
--          FT232_CLK => FT232_CLK,
          FT232_D_OUT => FT232_D_OUT,
          FT232_D_IN => FT232_D_IN,
          FT232_DIR => FT232_DIR,
          MWE => MWE,
          MCE => MCE,
          MWDATA => MWDATA,
          MRDATA => MRDATA,
          MADR => MADR
--          TEST => TEST
        );

   -- Clock process definitions
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/2;
		CLK <= '1';
		wait for CLK_period/2;
   end process;
 
    
    -- WRITE (FT232_H f[^ǂ݁AW[ɏ) -----------------------------
    --
    --      CLK _|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__ 10ns(100MHz)
    --    RXF_X ~~|_________________________________________|~~~~~~~~~~ 
    --     RD_X ~~~~~~~~|_______________________|~~~~~~~~~~~~~~~~~~~~~~ width=min30ns
    --     D_IN --------------------------------------- 
    --      RD _____________________|~~~~~|____________________________ 
    --
    --  FTSTATE   IDLE  | WR1 | WR2 | WR3 | WR4 | WR5 | WR6 | IDLE 
    -------------------------------------------------------------------
    
    -- READ (W[f[^ǂ݁AFT232_H ɏ) -----------------------------
    --
    --      CLK _|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__
    --    TXE_X ~~|_______________________|~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
    --    D_OUT -------------------------------
    --      DIR ______________|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|________________
    --     WR_X ~~~~~~~~~~~~~~~~~~~~|_______________________|~~~~~~~~~~~~~~~~ width=min30ns
    --  FTSTATE   IDLE        | RD1 | RD2 | RD3 | RD4 | RD5 | IDLE            
    -------------------------------------------------------------------
    
    -------------------------------------------------------------------
    --      MRD ________|~~~~~|______________________________________________
    --     ADR               | ADR+1
    -- CMDSTATE    RD1  | RD2 | RD1(IDLE) 
    ------------------------------------------------------------------
    
   -- Stimulus process
   stim_proc: process
   begin		
      RESET <= '1';
      wait for 20 ns;	
      RESET <= '0';
      FT232_RXF_X <= '1';
      FT232_TXE_X <= '1';
      FT232_D_IN  <= (others =>'0');
      MRDATA  <= (others =>'0');
      wait for CLK_period;
      
      -------------------------------------------- READ
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"5C";   -- READ command
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"12";   -- ADRS_H
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"34";   -- ADRS_L
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"00";   -- SIZE_H
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"02";   -- SIZE_L
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';     -- rŃf[^Mꍇ
      FT232_TXE_X <= '0';
      MRDATA  <= X"55";
      wait for CLK_period*5;
      
      FT232_TXE_X <= '1';
      wait for CLK_period*5;
      
      FT232_RXF_X <= '1';
      FT232_TXE_X <= '0';
      MRDATA  <= X"AA";
      wait for CLK_period*10;
      
      -------------------------------------------- WRITE
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"54";   -- WRITE command
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"56";   -- ADRS_H
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"78";   -- ADRS_L
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"00";   -- SIZE_H
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"00";   -- SIZE_L
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"66";   -- Data 1
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
      FT232_RXF_X <= '0';
      FT232_D_IN  <= X"BB";   -- Data 2
      wait for CLK_period*7;
      FT232_RXF_X <= '1';
      wait for CLK_period*4;
      
--      FT232_RXF_X <= '0';
      
      
      wait;
   end process;

END;
