--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:05:50 01/12/2010
-- Design Name:   
-- Module Name:   D:/ogchan/WorkShop/proj/20090214_APB-1/Radio/FPGA_APB-1_RADIO/iir_testbench.vhd
-- Project Name:  FPGA_APB1
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: iir
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY iir_testbench IS
END iir_testbench;
 
ARCHITECTURE behavior OF iir_testbench IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT iir
    PORT(
         RESET : IN  std_logic;
         CLK : IN  std_logic;
         NDIN : IN  std_logic;
         DIN_0 : IN  std_logic_vector(17 downto 0);
         DIN_1 : IN  std_logic_vector(17 downto 0);
         DIN_2 : IN  std_logic_vector(17 downto 0);
         DIN_3 : IN  std_logic_vector(17 downto 0);
--         NDOUT : OUT  std_logic;
         DOUT_0 : OUT  std_logic_vector(17 downto 0);
         DOUT_1 : OUT  std_logic_vector(17 downto 0);
         DOUT_2 : OUT  std_logic_vector(17 downto 0);
         DOUT_3 : OUT  std_logic_vector(17 downto 0);
         MEME : IN  std_logic;
         MWE : IN  std_logic;
         MADR : IN  std_logic_vector(15 downto 0);
         DATAIN : IN  std_logic_vector(7 downto 0);
         DATAOUT : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal RESET : std_logic := '0';
   signal CLK : std_logic := '0';
   signal NDIN : std_logic := '0';
   signal DIN_0 : std_logic_vector(17 downto 0) := (others => '0');
   signal DIN_1 : std_logic_vector(17 downto 0) := (others => '0');
   signal DIN_2 : std_logic_vector(17 downto 0) := (others => '0');
   signal DIN_3 : std_logic_vector(17 downto 0) := (others => '0');
   signal MEME : std_logic := '0';
   signal MWE : std_logic := '0';
   signal MADR : std_logic_vector(15 downto 0) := (others => '0');
   signal DATAIN : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
--   signal NDOUT : std_logic;
   signal DOUT_0 : std_logic_vector(17 downto 0);
   signal DOUT_1 : std_logic_vector(17 downto 0);
   signal DOUT_2 : std_logic_vector(17 downto 0);
   signal DOUT_3 : std_logic_vector(17 downto 0);
   signal DATAOUT : std_logic_vector(7 downto 0);
    
   constant CLK_period: time := 12.5ns;

BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: iir PORT MAP (
          RESET => RESET,
          CLK => CLK,
          NDIN => NDIN,
          DIN_0 => DIN_0,
          DIN_1 => DIN_1,
          DIN_2 => DIN_2,
          DIN_3 => DIN_3,
--          NDOUT => NDOUT,
          DOUT_0 => DOUT_0,
          DOUT_1 => DOUT_1,
          DOUT_2 => DOUT_2,
          DOUT_3 => DOUT_3,
          MEME => MEME,
          MWE => MWE,
          MADR => MADR,
          DATAIN => DATAIN,
          DATAOUT => DATAOUT
        );
 
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/2;
		CLK <= '1';
		wait for CLK_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
			MEME  <= '0';                       -- 
			MWE   <= '0';                  -- 
			MADR  <= "0000000000000000";  -- W[AhX
			DATAIN<= "00000000";  -- W[f[^
			
      RESET <= '1';
      wait for CLK_period;
      RESET <= '0';
      wait for CLK_period;
			
			MEME  <= '1';                       -- 
			MWE   <= '1';                  -- 
			MADR  <= "0000000111100000";  -- W[AhX
			DATAIN<= "00000011";  -- W[f[^
      wait for CLK_period;
			MEME  <= '0';                       -- 
			MWE   <= '0';                  -- 
      wait for CLK_period*2;
      
			MEME  <= '1';                       -- 
			MWE   <= '1';                  -- 
			MADR  <= "0000000111100001";  -- W[AhX
			DATAIN<= "00000000";  -- W[f[^
      wait for CLK_period;
			MEME  <= '0';                       -- 
			MWE   <= '0';                  -- 
      wait for CLK_period*2;
			
			MEME  <= '1';                       -- 
			MWE   <= '1';                  -- 
			MADR  <= "0000000111100010";  -- W[AhX
			DATAIN<= "00000000";  -- W[f[^
      wait for CLK_period;
			MEME  <= '0';                       -- 
			MWE   <= '0';                  -- 
      wait for CLK_period*2;
			
			MEME  <= '1';                       -- 
--			MWE   <= '0';                  -- 
			MADR  <= "0000000000000000";  -- W[AhX
--			DATAIN<= "00000000";  -- W[f[^
      wait for CLK_period*4;
			MEME  <= '0';                       -- 
--			MWE   <= '0';                  -- 
      wait for CLK_period*2;
			
			
			DIN_0 <= "000000100010001000"; -- 2184
			DIN_1 <= "000101010101010101"; -- 21845
			DIN_2 <= "001010101010101010"; -- 43690
			DIN_3 <= "010000000000000001"; -- 65537
      NDIN <= '1';
      wait for CLK_period;
      NDIN <= '0';
			
      wait for CLK_period*1000;
			DIN_0 <= "000000001000001000"; -- 520
--			DIN_0 <= "010000000000000000"; -- 65536
			DIN_1 <= "001000000000000000"; -- 32768
			DIN_2 <= "011000000000000000"; -- 98304
			DIN_3 <= "000100000000000000"; -- 16384
      
      wait for CLK_period*2048;
			DIN_0 <= "000010000000000111"; -- 8199
			DIN_1 <= "000010000000000000"; -- 8192
			DIN_2 <= "000010000000000000"; -- 8192
			DIN_3 <= "000010000000000000"; -- 8192
      
      wait for CLK_period*2048;
			DIN_0 <= "000001111101000000"; -- 8000
			DIN_1 <= "000001111101000000"; -- 8000
			DIN_2 <= "000001111101000000"; -- 8000
			DIN_3 <= "000001111101000000"; -- 8000
			
      wait for CLK_period*2048;
			DIN_0 <= "010000000000000000"; -- 65536
			DIN_1 <= "001000000000000000"; -- 32768
			DIN_2 <= "011000000000000000"; -- 98304
			DIN_3 <= "000100000000000000"; -- 16384
			
      wait for CLK_period*2048;
			DIN_0 <= "000100000000000000"; -- 16384
			DIN_1 <= "000100000000000000"; -- 16384
			DIN_2 <= "000100000000000000"; -- 16384
			DIN_3 <= "000100000000000000"; -- 16384
			
			
      wait;
   end process;

END;
