----------------------------------------------------------------------------------
--  
--        memcontrol.vhd        [
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
----------------------------------------------------------------------------------
--
--  WRITE
--      0   bit0=1 ƃ[݊JnAbit0=0 ƃ[ݒf
--      1   7:D32ʂWrbgǂݏo  4..3:SEL   2..1:ECi[݁j   0:RUNMODE(0:FREERUN 1:TRG)
--
--  READ
--      0   2:TRGD  1:TRGWAIT  0:START
--      1   ADRCOUNT(7 downto 0)
--      2   "000" & ADRCOUNT(12 downto 8);
--
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity memcontrol is
  Port (
    RESET     : in  STD_LOGIC;
    CLK       : in  STD_LOGIC;
    MCE       : in  STD_LOGIC;
    MWE       : in  STD_LOGIC;
    MADR      : in  STD_LOGIC_VECTOR (15 downto 0);
    MWDATA    : in  STD_LOGIC_VECTOR ( 7 downto 0);
    MRDATA    : out STD_LOGIC_VECTOR ( 7 downto 0);
    
    MEMDATAIN0: in  STD_LOGIC_VECTOR (39 downto 0);
    MEMDATAIN1: in  STD_LOGIC_VECTOR (39 downto 0);
    MEMDATAOUT: out STD_LOGIC_VECTOR (39 downto 0);
    MEMWE0    : in  STD_LOGIC;
    MEMWE1    : in  STD_LOGIC;
    TRG0      : in  STD_LOGIC;
    TRG1      : in  STD_LOGIC
  );
end memcontrol;

architecture RTL of memcontrol is
  
  signal CLKA         : std_logic;
  signal DINA         : std_logic_VECTOR(39 downto 0);
  signal ADRCOUNT     : std_logic_VECTOR(12 downto 0);
  signal WEA          : std_logic_VECTOR(0 downto 0);
  signal WEB          : std_logic_VECTOR(0 downto 0);
  signal CLKB         : std_logic;
  signal DINB         : std_logic_VECTOR(23 downto 0);
  signal DOUTB        : std_logic_VECTOR(39 downto 0);
  signal MEM          : std_logic_VECTOR(7 downto 0);
  
  signal START        : std_logic;                -- Jn
  signal D32          : std_logic;                -- ʂSrbgǂݍ݃[h
  signal SEL          : std_logic;                -- f[^ MWE I
  signal EC           : std_logic_VECTOR(1 downto 0);   -- End count mode
  signal ECVALUE      : std_logic_VECTOR(12 downto 0);  -- End count value
  signal ENDCOUNT     : std_logic_VECTOR(12 downto 0);  -- 0XFFF ɂȂ珑ݏI
  signal RUNMODE      : std_logic;                      -- 0: Jn 1: EC ɉ[ǂݍ񂾌 TRG ҂
  signal MODE         : std_logic_VECTOR(7 downto 0);
  signal TRGWAIT      : std_logic;                -- gK[|WV܂Ńf[^ǂݍ݂gK[҂
  signal TRGD         : std_logic;                -- gK[
  signal TRG          : std_logic;                -- gK[
  
  
  COMPONENT ram_8k_40
    PORT (
      clka : IN STD_LOGIC;
      wea : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
      addra : IN STD_LOGIC_VECTOR(12 DOWNTO 0);
      dina : IN STD_LOGIC_VECTOR(39 DOWNTO 0);
      douta : OUT STD_LOGIC_VECTOR(39 DOWNTO 0);
      clkb : IN STD_LOGIC;
      web : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
      addrb : IN STD_LOGIC_VECTOR(12 DOWNTO 0);
      dinb : IN STD_LOGIC_VECTOR(39 DOWNTO 0);
      doutb : OUT STD_LOGIC_VECTOR(39 DOWNTO 0)
    );
  END COMPONENT;
  
  
  begin
    
    U0 : ram_8k_40
    port map (
      clka  => CLK,
      wea   => WEA,
      addra => ADRCOUNT,
      dina  => DINA,
      douta => MEMDATAOUT,
      
      clkb  => CLK,
      web   => WEB,
      addrb => MADR(14 downto 2),
--      dinb  => MWDATA,
--      dinb  => "0000" & MWDATA & DINB,
      dinb  => "00000000" & MWDATA & DINB,
      doutb => DOUTB
    );
    
    
    WEA(0) <= '0'    when( START='0' ) else
              MEMWE0 when( SEL='0'   ) else
              MEMWE1;
    
    DINA <= MEMDATAIN0 when( SEL='0' ) else
            MEMDATAIN1;
    
    WEB <= "1" when( MWE='1' and MADR(15)='1' ) else "0";
    
    
    MEM    <= DOUTB(39 downto 32) when(D32='1')               else  -- ʂWrbgǂݍ݃[h
              DOUTB( 7 downto  0) when(MADR(1 downto 0)="00") else
              DOUTB(15 downto  8) when(MADR(1 downto 0)="01") else
              DOUTB(23 downto 16) when(MADR(1 downto 0)="10") else
              DOUTB(31 downto 24);
    MRDATA <= MEM                 when(MADR(15)='1')                           else
              "00000000"          when(MCE='0')                                else
              "00000"& TRGD & TRGWAIT & START  when(MADR(1 downto 0)="00")     else -- STATUS
              ADRCOUNT(7 downto 0) when(MADR(1 downto 0)="01")                 else
              "000" & ADRCOUNT(12 downto 8);
    
    ------------------------------------------------------------------
    --  [݃f[^
    ------------------------------------------------------------------
    process( CLK ) begin
      if( rising_edge(CLK) ) then
        if( MWE='1' and MADR(15)='1' ) then
          case MADR( 1 downto 0 ) is
            when( "00" ) => DINB( 7 downto  0) <= MWDATA;    -- 
            when( "01" ) => DINB(15 downto  8) <= MWDATA;    -- 
            when  others => DINB(23 downto 16) <= MWDATA;    -- ;
          end case;
        end if;
      end if;
    end process;
    
    
    ------------------------------------------------------------------
    
    ECVALUE <= "0" & X"009" when( EC="00" ) else    -- TRGWAIT  TRGD ܂ł 1 clk ̂ 1 Ă
               "0" & X"401" when( EC="01" ) else
               "1" & X"001" when( EC="10" ) else
               "1" & X"C01";
    
    D32 <= MODE(7);
    SEL <= MODE(3);
    EC  <= MODE(2 downto 1);
    RUNMODE  <= MODE(0);
    
    
    ------------------------------------------------------------------
    --  ݒ
    ------------------------------------------------------------------
    process( RESET, CLK ) begin
      if( RESET='1' ) then
        MODE <= ( others => '0');
      elsif( rising_edge(CLK) ) then
        if( MWE='1' and MCE='1' ) then
          if( MADR(0)='1' ) then 
            MODE <= MWDATA;
          end if;
        end if;
      end if;
    end process;
    
    
    ------------------------------------------------------------------
    --  [݃JE^
    ------------------------------------------------------------------
    process( RESET, CLK ) begin
      if( RESET='1' ) then
        START<='0';
      elsif( rising_edge(CLK) ) then
        if( MWE='1' and MCE='1' ) then
          if( MADR(0)='0' ) then 
            if( MWDATA(0)='1' ) then      -- ݊Jn
              START <= '1';
              ADRCOUNT <= (others => '0');
              ENDCOUNT <= ECVALUE;        -- EC ɉlZbg
            else
              START <= '0';
            end if;
          end if;
        elsif( WEA(0)='1' ) then           -- START='1' ̂Ƃ
          ADRCOUNT <= ADRCOUNT+1;
          if( TRGD='1' ) then
            ENDCOUNT <= ENDCOUNT + 1;
            if( ENDCOUNT = X"1FFF" ) then
              START <= '0';
            end if;
          end if;
        end if;
      end if;
    end process;
    
    
    ------------------------------------------------------------------
    --  gK[
    ------------------------------------------------------------------
    TRG <= TRG0 when( SEL='0' ) else
           TRG1;
    
    process( RESET, CLK ) begin
      if( RESET='1' ) then
        TRGD    <= '0';
        TRGWAIT <= '0';
      elsif( rising_edge(CLK) ) then
        if( START='1' ) then
          if( WEA(0)='1' ) then 
            if( ( EC="00" and ADRCOUNT( 3)='1'             ) or
                ( EC="01" and ADRCOUNT(10)='1'             ) or
                ( EC="10" and ADRCOUNT(12)='1'             ) or
                ( EC="11" and ADRCOUNT(12 downto 10)="111" ) ) then
              TRGWAIT <= '1'; -- gK[|WV܂Ńf[^ǂݍ݂gK[󂯕t
              if( RUNMODE='0' ) then
                TRGD <= '1';
              end if;
            end if;
          end if;
          if( TRGWAIT='1' and TRG='1' ) then
            TRGD <= '1'; -- gK[
          end if;
        else
          TRGD    <= '0';
          TRGWAIT <= '0';
        end if;
      end if;
    end process;
    
    
end RTL;

