--------------------------------------------ӂ[--------------------------------------
--  
--        oscilloscope.vhd        IVXR[v
--  
--        (c)201/07/16  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--
----------------------------------------------------------------------------------
--  
-- WRITE
--    0x00   7 6 5 4 3 2 1 0
--           |         +-+-+-- THRESHOLD  0:32  1:64   2:128   ...  7:4096
--           +---------------- TRG EDGE   0:オ  1:
--  
--  オ́AXVh[؂ƂŃgK[
--  ́AXVh[؂ƂŃgK[
--  
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity oscilloscope is
  port (
    RESET   : in  std_logic;                      -- 
    CLK     : in  std_logic;
    
    MCE     : in  std_logic;                      -- Cl[u
    MWE     : in  std_logic;                      -- 
    MADR    : in  std_logic_vector(15 downto 0);  -- AhX
    MWDATA  : in  std_logic_vector( 7 downto 0);  -- ރf[^
    
    I_IN    : in std_logic_vector(17 downto 0);   -- gϊ CIC ʂM
    Q_IN    : in std_logic_vector(17 downto 0);
    ND      : in  std_logic;                      -- I_IN, Q_IN L
    
    DSIGOUT : out std_logic;                     -- g``ăfW^M
    TRG     : out std_logic                      -- gK[
    
  );
end oscilloscope;


architecture RTL of oscilloscope is
  signal GT       : std_logic;                      -- MXVhȏォ
  signal LT       : std_logic;                      -- MXVhȉ
  signal DSIG     : std_logic;                      -- g``ăfW^M
  signal DSIG1    : std_logic;                      -- 
  
  signal TRGEDGE  : std_logic;                      -- gK[GbW
  signal TH       : std_logic_vector( 2 downto 0);  -- XVh
  
begin
  
  DSIGOUT <= DSIG;
  
  GT <= '0' when( I_IN(17)='1' )                                  else  -- 
        '1' when( I_IN(16 downto  7)/="0000000000" and TH="000" ) else  --   32ȏ
        '1' when( I_IN(16 downto  8)/="000000000"  and TH="001" ) else  --   64ȏ
        '1' when( I_IN(16 downto  9)/="00000000"   and TH="010" ) else  --  128ȏ
        '1' when( I_IN(16 downto 10)/="0000000"    and TH="011" ) else  --  256ȏ
        '1' when( I_IN(16 downto 11)/="000000"     and TH="100" ) else  --  512ȏ
        '1' when( I_IN(16 downto 12)/="00000"      and TH="101" ) else  -- 1024ȏ
        '1' when( I_IN(16 downto 13)/="0000"       and TH="110" ) else  -- 2048ȏ
        '1' when( I_IN(16 downto 14)/="000"        and TH="111" ) else  -- 4096ȏ
        '0';
  
  LT <= '0' when( I_IN(17)='0' )                                  else  -- 
        '1' when( I_IN(16 downto  7)/="1111111111" and TH="000" ) else  --   -32ȉ
        '1' when( I_IN(16 downto  8)/="111111111"  and TH="001" ) else  --   -64ȉ
        '1' when( I_IN(16 downto  9)/="11111111"   and TH="010" ) else  --  -128ȉ
        '1' when( I_IN(16 downto 10)/="1111111"    and TH="011" ) else  --  -256ȉ
        '1' when( I_IN(16 downto 11)/="111111"     and TH="100" ) else  --  -512ȉ
        '1' when( I_IN(16 downto 12)/="11111"      and TH="101" ) else  -- -1024ȉ
        '1' when( I_IN(16 downto 13)/="1111"       and TH="110" ) else  -- -2048ȉ
        '1' when( I_IN(16 downto 14)/="111"        and TH="111" ) else  -- -4096ȉ
        '0';
  
  ------------------------------------------------------------------
  --    gK[o
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( ND='1' ) then
        if( TRGEDGE='0' ) then     --オ
          if( DSIG='0' and I_IN(17)='0' ) then -- ɂȂ
            DSIG <= '1';
          elsif( DSIG='1' and LT='1' ) then -- XVhȉɂȂ
            DSIG <= '0';
          end if;
        else
          if( DSIG='1' and I_IN(17)='1' ) then -- ɂȂ
            DSIG <= '0';
          elsif( DSIG='0' and GT='1' ) then -- XVhȏɂȂ
            DSIG <= '1';
          end if;
        end if;
      end if;
      
      DSIG1 <= DSIG;
      if( TRGEDGE='0' ) then     --オ
        if( DSIG='1' and DSIG1='0' ) then
          TRG <= '1';
        else
          TRG <= '0';
        end if;
      else
        if( DSIG='0' and DSIG1='1' ) then
          TRG <= '1';
        else
          TRG <= '0';
        end if;
      end if;
      
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --    ݒ
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( MWE='1' and MCE='1') then
        TRGEDGE <= MWDATA(7);             -- gK[GbW  0:オ  1:
        TH      <= MWDATA(2 downto 0);    -- XVh
      end if;
    end if;
  end process;
  
  
end RTL;

