----------------------------------------------------------------------------------
--  
--        shiftra32.vhd        ZpEVtg@32rbgf[^
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
--
--Selected Device : 6slx9tqg144-3 
--
--
--Slice Logic Utilization: 
-- Number of Slice LUTs:                   96  out of   5720     1%  
--    Number used as Logic:                96  out of   5720     1%  
--
--Slice Logic Distribution: 
-- Number of LUT Flip Flop pairs used:     96
--   Number with an unused Flip Flop:      96  out of     96   100%  
--   Number with an unused LUT:             0  out of     96     0%  
--   Number of fully used LUT-FF pairs:     0  out of     96     0%  
--   Number of unique control sets:         0
--
--
--   Minimum period: No path found
--   Minimum input arrival time before clock: No path found
--   Maximum output required time after clock: No path found
--   Maximum combinational path delay: 8.851ns
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity shiftra32 is 
  port (
    X   : in  std_logic_vector( 31 downto 0 ); -- 
    Y   : out std_logic_vector( 31 downto 0 ); -- o̓f[^
    N   : in  std_logic_vector(  4 downto 0 )  -- Vtg
  );
end shiftra32;


------------------------------------------------------------------------------
architecture RTL of shiftra32 is
  
  signal X1 : std_logic_vector( 31 downto 0 ); -- 1 bit Vtg
  signal X2 : std_logic_vector( 31 downto 0 ); -- 2 bit Vtg
  signal X4 : std_logic_vector( 31 downto 0 ); -- 4 bit Vtg
  signal X8 : std_logic_vector( 31 downto 0 ); -- 8 bit Vtg
  
  begin
    
    X1 <= X  when( N(0)='0' ) else
          X(31) & X(31 downto 1);
    
    X2 <= X1 when( N(1)='0' ) else
          X1(31) & X1(31) & X1(31 downto 2);
    
    X4 <= X2 when( N(2)='0' ) else
          X2(31) & X2(31) & X2(31) & X2(31) & X2(31 downto 4);
    
    X8 <= X4 when( N(3)='0' ) else
          X4(31) & X4(31) & X4(31) & X4(31) & X4(31) & X4(31) & X4(31) & X4(31) & X4(31 downto 8);
    
    Y  <= X8 when( N(4)='0' ) else
          X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31) & X8(31 downto 16);
    
    
  end RTL;
----------------------------- end of architecture ----------------------------

